package vpn

import (
	"github.com/xtaci/kcp-go"
	"net"
)

const (
	KcpKey  = "WUFHO*&#"
	DataKey = "JCB*&#(U"

	DSCP    = 9
	SockBuf = 4194304
	SndWnd  = 512
	RcvWnd  = 512
)

type Config struct {
	NetAddr       string     // NetAddr UDP监听地址(可只填端口)
	IFaceIp       net.IP     // IFaceIp 网卡ip
	IFaceNet      *net.IPNet // IFaceNet 网络ip
	ServerIFaceIP string     // ServerIFaceIP 服务器虚拟IP - 服务端不需要填
	Password      string     // Password 服务端链接密码
	Compress      bool       // Compress 是否压缩数据
	Obfs          bool       // Obfs 是否开启异或混淆 加强数据安全
}

func splitRead(session *kcp.UDPSession, expectLen int, packet []byte) (int, error) {
	count := 0
	splitSize := 99
	for count < expectLen {
		receiveSize := splitSize
		if expectLen-count < splitSize {
			receiveSize = expectLen - count
		}
		n, err := session.Read(packet[count : count+receiveSize])
		if err != nil {
			return count, err
		}
		count += n
	}
	return count, nil
}
